/*
**
****************************************************************************
**
**
**		Copyright (c) 2004/2005 - Atmel Corporation
**		L
**
** 		: AVR LIN]u
** 		:
** 		: ޯĎԌvZpߊl͊荞ٰ
** ړIΏ	: AVR ATmega48/88/168
** ߲	: IAR Embedded Workbench
**
** : t:	  : :
** 1.0 19.08.2004 E.G.  쐬
** 1.1 19.11.2004 E.G.  3RCZ (vZꂽOSCCAĹ})
** 1.2 25.11.2004 E.G.  8.0RCU3iK
** 1.3 08.06.2005 E.G.  gsAłɑ΂sf
**
**  -
**
** ATMEL - 2004/2005
** SĂ̿ĳ ۸т͂ǂȎނ̕ۏ؂Ȃ"󂻂̂"Œ񋟂܂B
** ATMEL͂ǂȖړIɑ΂Ă񋟂fނ̓K۔F܂BATMEL͑SĂ̈
** ٓIȕۏ؁AړIւ̓KALA@܂݁A񋟂ĳɊ֘A
** SĂ̕ۏ؂ƏŔ۔F܂B̿ĳ ۸т̎gp̌ʂł
** ĂAǂȊԐړIApIȑQA܂͂ǂȑQɑ΂ĂAƂɂ
** SATMELɐӔCȂł傤B
****************************************************************************
**
*/
//
/*_____ ݸٰ ____________________________________________________________*/
#include "config.h"
#include "lib_mcu/lin_uart/slave_lin.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

// LINsUZɑ΂3ɕč܂B
// =16i, 2iK=8i, 3(ŏI)iK=4i

// gp		: /1(16ޯ)+ߊl͕
// юg	: 8MHzRCU

/*_____ ` _______________________________________________________________*/
volatile U8 Timer_IC_cnt;
volatile U8 _lin_synchronized;	// ݒ̏ꍇLIN呕u(2%ȓ)ς݁B
volatile U16 TimeStamp_IC1;
volatile U16 TimeStamp_IC2;

//**************************************************************************
// /1ߊl͊荞ݏٰ
// (ŏד̂߂)LIN呕uޯĎԒlvZɎgp
//**************************************************************************
#pragma vector= TIMER1_CAPT_vect
__interrupt void TIMER1_CAPT_ISR (void){
#ifdef _RUN_TIME_RC_CALIBRATION_ENABLE
  U8 new_osccal;
  U8 osccal_prior_synchr;
  U8 osccal_step;
  U16 measured_master_tbit;
  signed int tbit_diff;

//******************* 1 (A) *******************//
  if (Timer_IC_cnt == 0) {			// 1s[ŁA
	TimeStamp_IC1 = ICR1;			// 1s(1~)[vl擾/ۑ
  } else if (Timer_IC_cnt == 1) {	// 1s[ŁA
	TimeStamp_IC2 = ICR1;			// 1s(2~)[vl擾/ۑ
	TCCR1B = (1<<ICES1) | (1<<CS10);	// pɏ㏸[ߊl,OuȂɕύX
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;	// ޯĎԎ擾
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;		// 덷l擾
	osccal_prior_synchr = OSCCAL;	// OSCCALlۑ
	osccal_step = 16;				// OSCCALύXi擾

	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)) {	// ͈͓ŁA
	  Timer_stop_capture();			// Z~(T/C1~)
	  lin_synchronized = 1;			// LIN]u퓯ς׸ސݒ
	} else {																				// ͈͊OŁA
	  _lin_synchronized = 0;		// LIN]u퓯ς׸މ
	  if (tbit_diff > 0) {									// ႷȂA
		new_osccal = osccal_prior_synchr + osccal_step;		// VOSCCALl=OSCCALl+16
	  } else {												// ȂA
		new_osccal = osccal_prior_synchr - osccal_step;		// VOSCCALl=OSCCALl-16
	  }
	  if (new_osccal<128 & osccal_prior_synchr>=128) {		// OSCCAL㔼gpŐVOSCCALl128ȂA
		new_osccal = 128;									// 㔼ŒlɕύX
	  }
	  if (new_osccal>=128 & osccal_prior_synchr<128) {		// OSCCALOgpŐVOSCCALl128ُȂA
		new_osccal = 127;									// OōlɕύX
	  }
	  OSCCAL = new_osccal;			// OSCCALlXV(̏㏸[܂ł1ޯĎԂňۏ)
	}

//******************* 2 (B)*******************//
  } else if (Timer_IC_cnt == 2) {	// 2s[ŁA
	TimeStamp_IC1 = ICR1;			// 2s(2㏸)[vl擾/ۑ
  } else if (Timer_IC_cnt == 3) {	// 2s[ŁA
	TimeStamp_IC2 = ICR1;			// 2s(3㏸)[vl擾/ۑ
	TCCR1B &= ~(1<<ICES1);			// pɉ~[ߊl,OuȂɕύX
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;	// ޯĎԎ擾
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;		// 덷l擾
	osccal_prior_synchr = OSCCAL;	// OSCCALlۑ
	osccal_step = 8;				// OSCCALύXi擾

	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)) {	// ͈͓ŁA
	  Timer_stop_capture();			// Z~(T/C1~)
	  _lin_synchronized = 1;		// LIN]u퓯ς׸ސݒ
	} else {																				// ͈͊OŁA
	  _lin_synchronized = 0;		// LIN]u퓯ς׸މ
	  if (tbit_diff > 0) {									// ႷȂA
		new_osccal = osccal_prior_synchr + osccal_step;		// VOSCCALl=OSCCALl+8
	  } else {												// ȂA
		new_osccal = osccal_prior_synchr - osccal_step;		// VOSCCALl=OSCCALl-8
	  }
	  if (new_osccal<128 & osccal_prior_synchr>=128) {		// OSCCAL㔼gpŐVOSCCALl128ȂA
		new_osccal = 128;									// 㔼ŒlɕύX
	  }
	  if (new_osccal>=128 & osccal_prior_synchr<128) {		// OSCCALOgpŐVOSCCALl128ُȂA
		new_osccal = 127;									// OōlɕύX
	  }
	  OSCCAL = new_osccal;			// OSCCALlXV(̏㏸[܂ł1ޯĎԂňۏ)
	}

//******************* 3 (C)*******************//
  } else if (Timer_IC_cnt == 4) {	// 3s[ŁA
	TimeStamp_IC1 = ICR1;			// 2s(4~)[vl擾/ۑ
  } else if (Timer_IC_cnt ==5) {	// 3s[ŁA
	TimeStamp_IC2 = ICR1;			// 3s(5~)[vl擾/ۑ
	measured_master_tbit = TimeStamp_IC2 - TimeStamp_IC1;	// ޯĎԎ擾
	tbit_diff = EXPECTED_TBIT - measured_master_tbit;		// 덷l擾
	osccal_prior_synchr = OSCCAL;	// OSCCALlۑ
	osccal_step = 4;				// OSCCALύXi擾

	if ((tbit_diff <= TBIT_DIFF_THRESHOLD_MAX) && (tbit_diff >= TBIT_DIFF_THRESHOLD_MIN)) {	// ͈͓ŁA
	Timer_stop_capture();			// Z~(T/C1~)
	_lin_synchronized = 1;			// LIN]u퓯ς׸ސݒ
	} else {																				// ͈͊OŁA
	  _lin_synchronized = 0;		// LIN]u퓯ς׸މ
	  if (tbit_diff > 0) {									// ႷȂA
		new_osccal = osccal_prior_synchr + osccal_step;		// VOSCCALl=OSCCALl+4
	  } else {												// ȂA
		new_osccal = osccal_prior_synchr - osccal_step;		// VOSCCALl=OSCCALl-4
	  }
	  if (new_osccal<128 & osccal_prior_synchr>=128) {		// OSCCAL㔼gpŐVOSCCALl128ȂA
		new_osccal = 128;									// 㔼ŒlɕύX
	  }
	  if (new_osccal>=128 & osccal_prior_synchr<128) {		// OSCCALOgpŐVOSCCALl128ُȂA
		new_osccal = 127;									// OōlɕύX
	  }
	  OSCCAL = new_osccal;			// OSCCALlXV(̏㏸[܂ł1ޯĎԂňۏ)
	  Timer_stop_capture();			// Z~(T/C1~)
	  _lin_synchronized = 1;		// LIN]u퓯ς׸ސݒ
	}
  }

  Timer_IC_cnt ++ ;					// Ԕԍis
#endif
}
